package com.company;

import com.company.throwable.Throwable;

public abstract class Fighter implements Kickable, Throwable {
    private int health;
    private int damage;
    private String name;

    public Fighter() {
        this(10, 5, "Unknown Fighter");
    }

    public Fighter(int health, int damage, String name) {
        this.health = health;
        this.damage = damage;
        this.name = name;
    }

    public String getName() {
        return this.name;
    }

    public int getStrength() {
        return this.damage;
    }

    public int getHealth() {
        return this.health;
    }

    public String toString() {
        if(this.health <= 0) {
            return this.name + " is dead.";
        } else {
            return this.name + " has " + this.health + " health left.";
        }
    }

    public void damage(int damage) {
        System.out.println(this.name + " got hurt for " + damage + " health!");
        this.health -= damage;
    }

    @Override
    public void damage(Fighter fighter) {
        System.out.println(fighter.getName() + " kicked " + this.name);
        this.damage(fighter.getStrength());
    }

    @Override
    public void throwMe(Fighter fighter) {
        System.out.println(fighter.getName() + " throws " + this.getName() + "!");
    }
}
